config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  mount Rswag::Ui::Engine => '/api-docs'
  mount Rswag::Api::Engine => '/api-docs'

  post '/informed_consent' => 'questionnaire#create_informed_consent'
  get '/klaar' => 'reward#index'
  post '/' => 'questionnaire#create'
  root to: 'token_authentication#show'
  resources :mentor_overview, only: [:index]
  resources :questionnaire, only: %i[index show create destroy], param: :uuid do
    collection do
      get 'preference/:uuid', to: 'questionnaire#preference', as: 'preference'
      get :interactive
      post :interactive_post
      post :interactive_render
      post :from_json
    end
  end
  resource :person, only: %i[edit update] do
    get 'unsubscribe'
  end
  resource :language, only: %i[show] do
    collection do
      post :change
    end
  end

  get 'o', to: 'one_time_response#show', as: 'one_time_response'

  # Admin panel
  scope path: :admin do
    get '/', to: 'admin#index', as: 'admin'
    get 'export', to: 'admin#export', as: 'admin_export'
    get 'preview_overview', to: 'admin#preview_overview', as: 'admin_preview_overview'
    get 'organization_overview', to: 'admin#organization_overview', as: 'admin_organization_overview'

    get 'person_export', to: 'admin#person_export', as: 'admin_person_export'
    get 'identifier_export', to: 'admin#identifier_export', as: 'admin_identifier_export'
    get 'protocol_subscription_export', to: 'admin#protocol_subscription_export', as: 'admin_protocol_subscription_export'
    get 'invitation_set_export', to: 'admin#invitation_set_export', as: 'admin_invitation_set_export'
    get 'protocol_transfer_export', to: 'admin#protocol_transfer_export', as: 'admin_protocol_transfer_export'
    get 'questionnaire_export/:id', to: 'admin#questionnaire_export', as: 'admin_questionnaire_export'
    get 'response_export/:id', to: 'admin#response_export', as: 'admin_response_export'
    get 'reward_export', to: 'admin#reward_export', as: 'admin_reward_export'
    get 'proof_of_participation_export', to: 'admin#proof_of_participation_export', as: 'admin_proof_of_participation_export'

    post 'preview', to: 'admin#preview', as: 'admin_preview'
    get 'preview', to: 'admin#preview', as: 'admin_preview_get'
    post 'preview_done', to: 'admin#preview_done', as: 'admin_preview_done'
    get '*path', to: 'admin#index'
  end

  # Static pages
  get 'disclaimer', to: 'static_pages#disclaimer', as: 'disclaimer'

  # Status
  get '/status' => 'status#show'

  namespace :api do
    namespace :v1 do


      # JWT APIs
      scope module: :jwt_api do
        resources :one_time_response, only: [:index, :show], param: :otr
        resources :questionnaire, only: [:index, :show, :create, :update], param: :key do
          resources :results, only: [] do
            collection do
              get :distribution
            end
          end
        end
        resources :response, only: [:show, :index, :create], param: :uuid do
          collection do
            get :completed
            get :all
          end
        end
        resources :auth_user, only: [:create]
        resources :people, only: [:create] do
          collection do
            get :list_children
          end
          member do
            put :update_child
            delete :destroy_child
          end
        end

        resources :protocol_subscriptions, only: [] do
          collection do
            # @note Watch out! This can be interpreted as a show route later.
            get :mine # just retrieves active protocol subscriptions that are filled out "for myself"
            get :my_active_and_inactive
          end
        end
        resources :protocol, only: [:index] do
          member do
            post :preview
          end
        end
      end

      # JWT and Cookie apis
      # TODO in V2 API, rename to people.
      scope module: :cookie_and_jwt_api do
        resources :protocol_subscriptions, only: [:create, :show, :destroy]

        resources :person, only: [] do
          collection do
            get :me
            get :my_students
            put :update
            delete :destroy
          end
        end
      end

      # Basic auth APIs
      namespace :basic_auth_api do
        resources :scheduling, only: [] do
          collection do
            post :daily_at_one_am
            post :daily_at_two_am
            post :daily_at_three_am
            post :daily_at_four_am
            post :daily
            post :hourly
            post :thirty_minutely
            post :five_minutely
            post :minutely
          end
        end

        resources :protocols, only: %i[create]

        resources :protocol_subscriptions, only: [:create, :destroy, :update] do
          collection do
            get :delegated_protocol_subscriptions
            delete :destroy_delegated_protocol_subscriptions
          end
        end
        resources :person, only: %i[create update destroy] do
          collection do
            get :show_list
          end
          member do
            post :change_to_mentor
          end
        end

        resources :questionnaires, only: [:create, :show]
      end

      # Admin APIs
      namespace :admin do
        resources :team, only: [:show], param: :group
        resources :organization, only: [:show], param: :group
      end

      # Public APIs
      resources :statistics, only: [:index]
      resources :settings, only: [:index]
    end
  end
  match '/',
        controller: 'application',
        action: 'options',
        constraints: { method: %w[OPTIONS POST PUT PATCH DELETE] },
        via: %i[options post put patch delete]
  match '*path', via: :all, to: 'application#page_not_found'
end

app/views/admin/_menu.html.haml
%ul#slide-out.sidenav.sidenav-fixed
  %li
    .user-view
      = image_tag Rails.application.config.settings.logo.fallback_logo, style: 'max-width: 100%; height: 64px'
    = link_to(admin_path, class: 'waves-effect') do
      %span.black-text Admin interface 
  %li
    = link_to(admin_path, class: 'waves-effect') do
      %i.material-icons> dashboard
      Dashboard
  %li
    = link_to(admin_export_path, class: 'waves-effect') do
      %i.material-icons> import_export
      Exports
  %li
    = link_to(admin_preview_overview_path, class: 'waves-effect') do
      %i.material-icons> question_answer
      Preview questionnaires
  %li
    = link_to(admin_organization_overview_path, class: 'waves-effect') do
      %i.material-icons> apps
      Organization overview
  %li
    %div.divider
  %li
    %a.subheader Dummy applications
  %li
    = link_to("#{ENV['HOST_URL']}/dummy/mentor", class: 'waves-effect', target: '_blank') do
      %i.material-icons> label
      Mentor dummy
    = link_to("#{ENV['HOST_URL']}/dummy/student", class: 'waves-effect', target: '_blank') do
      %i.material-icons> label
      Student dummy
.fixed-action-btn.hide-on-large-only
  %a.btn-floating.btn-large.accent-color.sidenav-trigger{"data-target" => "slide-out", :href => "#"}
    %i.material-icons menu
  %ul
    %li
      = link_to(admin_path, class: 'btn-floating') do
        %i.material-icons> dashboard
    %li
      = link_to(admin_export_path, class: 'btn-floating') do
        %i.material-icons> import_export
    %li
      = link_to(admin_preview_overview_path, class: 'btn-floating') do
        %i.material-icons> question_answer
    %li
      = link_to(admin_organization_overview_path, class: 'btn-floating') do
        %i.material-icons> apps

app/views/admin/export.html.haml
= render partial: 'menu'
.container
  .row
    .admin-interface
      .col.s12
        %h1 Export data
      .col.s12
        .section
          %ul.collapsible
            %li
              .collapsible-header
                %i.material-icons event_note
                Current Study
              .collapsible-body
                %ul.collection
                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title People
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_person_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  -if Rails.application.config.settings.feature_toggles.allow_identifier_export
                    %li.collection-item.avatar{:style => "min-height:65px"}
                      %i.large.material-icons.circle.blue.lighten-2 description
                      %span.title Identifiers
                      %p
                        = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                          admin_identifier_export_path(format: 'csv'),
                          class: 'waves-effect waves-light btn download-button')

                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title ProtocolSubscriptions
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_protocol_subscription_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title InvitationSets
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_invitation_set_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title ProtocolTransfers
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_protocol_transfer_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title Rewards
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_reward_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  %li.collection-item.avatar{:style => "min-height:65px"}
                    %i.large.material-icons.circle.blue.lighten-2 description
                    %span.title Proof of participation
                    %p
                      = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Download',
                        admin_proof_of_participation_export_path(format: 'csv'),
                        class: 'waves-effect waves-light btn download-button')

                  - @normal_questionnaires.each do |questionnaire|
                    %li.collection-item.avatar{:style => "min-height:65px"}
                      %i.large.material-icons.circle.blue.lighten-2 description
                      %span.title
                        Questionnaire: #{questionnaire.name}
                      %p
                        = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Definition',
                          admin_questionnaire_export_path(id: questionnaire.name, format: 'csv'),
                          class: 'waves-effect waves-light btn download-button')
                        = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Responses',
                          admin_response_export_path(id: questionnaire.name, format: 'csv'),
                          class: 'waves-effect waves-light btn download-button')
            %li
              .collapsible-header
                %i.material-icons event_note
                Pilot Data
              .collapsible-body
                %ul.collection
                  - @pilot_questionnaires.each do |questionnaire|
                    %li.collection-item.avatar{:style => "min-height:65px"}
                      %i.large.material-icons.circle.blue.lighten-2 description
                      %span.title
                        Questionnaire: #{questionnaire.name}
                      %p
                        = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Definition',
                          admin_questionnaire_export_path(id: questionnaire.name, format: 'csv'),
                          class: 'waves-effect waves-light btn download-button')
                        = link_to(content_tag(:i, 'system_update_alt', class: 'material-icons left') + 'Responses',
                          admin_response_export_path(id: questionnaire.name, format: 'csv'),
                          class: 'waves-effect waves-light btn download-button')

app/views/admin/index.html.haml
= render partial: 'menu'
.container
  .row
    .admin-interface
      .col.s12
        %h1 Dashboard
      - if Reward.total_earned_euros.positive? || Reward.max_still_earnable_euros.positive?
        .col.s12
          .section
            %h4 Reward Money
            %p= "Total earned so far: #{print_as_money(Reward.total_earned_euros)}"
            %p= "Can still be earned: #{print_as_money(Reward.max_still_earnable_euros)}"
      - if Rails.application.config.settings.application_name == 'u-can-act' # vieze hack
        .col.s12
          .section
            %h4 Evaluatieonderzoek
            %p= "Aantal keren op de link geklikt: #{Protocol.find_by(name: 'evaluatieonderzoek')&.protocol_subscriptions&.count}"
            %p= "Aantal keren informed consent geaccepteerd: #{Protocol.find_by(name: 'evaluatieonderzoek')&.protocol_subscriptions&.where('informed_consent_given_at IS NOT NULL')&.count}"
            %p= "Aantal keren vragenlijst is ingevuld: #{Measurement.find_by(questionnaire_id: Questionnaire.find_by(name: 'evaluatieonderzoek')&.id)&.responses&.where('completed_at IS NOT NULL')&.count}"
            %p= "Aantal keren emailadres & ip opgegeven: #{Person.where('email IS NOT NULL AND ip_hash IS NOT NULL').count}"
      - if Rails.application.config.settings.application_name == 'ikia' # vieze hack
        .col.s12
          .section
            %h4 Ieder Kind Is Anders
            %p= "Aantal geregistreerde ouders: #{Person.where(account_active: true, role_id: Role.find_by(title: 'parents')&.id).count}"
            %p= "Aantal geregistreerde kinderen: #{Person.where(account_active: true, role_id: Role.find_by(title: 'kids')&.id).count}"
            %p= "Aantal geregistreerde jongeren 12-15: #{Person.where(account_active: true, role_id: Role.find_by(title: 'teens')&.id).count}"
            %p= "Aantal geregistreerde jongeren 16-18: #{Person.where(account_active: true, role_id: Role.find_by(title: 'youngadults')&.id).count}"
      .col.s12
        .section
          = react_component('admin_page_components/Statistics')
      .col.s12
        .section
          %h4 Elaborate functionality
          = react_component('AdminRouter')

app/views/admin/organization_overview.html.haml
= render partial: 'menu'
.container
  .row
    .admin-interface
      .col.s12
        %h1 Organization overview
      .col.s6
        .section
        = react_component('AdminRouter')

app/views/admin/preview.html.haml
= render partial: 'shared/header'
= @content

app/views/admin/preview_overview.html.haml
- locales = Rails.application.config.i18n.available_locales.map(&:to_s)
= render partial: 'menu'
.container
  .row
    .admin-interface
      .col.s12
        %h1 Preview questionnaires
        .section
          = form_tag('/admin/preview', method: 'post') do
            .row
              .col.s12
                = select_tag(:id, options_for_select(questionnaire_select_options(@normal_questionnaires.sort_by{|x|x.name}), disabled: '', selected: ''), required: true)
            .row
              .col.s12
                %h5 Locale
                - locales.each do |locale|
                  %p
                    %label
                      %input{name: 'locale', type: 'radio', value: locale, checked: Rails.application.config.i18n.default_locale.to_s == locale}
                      %span=locale
            .row
              .col.s12
                = button_tag('Preview questionnaire', type: 'submit', class: 'btn waves-effect waves-light', data: { disable_with: I18n.t('questionnaires.busy') })